/* ISC (c) 2018+ Jackens * https://github.com/jackens/nanolight */

if (typeof window !== 'undefined') {
  window['module.exports'] = window['module.exports'] || {}
  window.require = window.require || function (id) { return window['module.exports'][id] }
}

(function () {
  var N = 'nanolight-'
  var X = '<span class="'
  var Y = '">'
  var Z = '</span>'
  var S = '-string'
  var C = '-comment'
  var D = N + 'char'
  var W = N + 'word'
  D += ' ' + D + '-'
  W += ' ' + W + '-'
  var Q = 'quote'
  var I = 'single-'
  var R = /(\d+(?:\.\d+)?)|(!|\$|%|&|\(|\)|\*|\+|,|-|\.|\/|:|;|<|=|>|\?|@|\[|\\|\]|\^|_|\{|\||\}|~)|([a-zA-Z_]\w+)/

  function F (t, i, a, m, n, c, w) {
    m = i % 4
    if (m) {
      return
    }
    n = a[++i]
    c = a[++i]
    w = a[++i]
    return (n ? [t, X, N, 'number', Y, n, Z] : c ? [t, X, D, H(c), Y, c, Z] : w ? [t, X, W, w, Y, w, Z] : [t]).join('')
  }

  function G (c, t, a, z, T, A, Z) {
    z = z || a
    T = t.length
    A = a.length
    Z = z.length
    if (T >= A + Z && t.substring(0, A) === a && t.substring(T - Z, T) === z) {
      return { c: c, t: t.substring(A, T - Z) }
    }
  }

  function H (c) {
    c = c.charCodeAt(0)
    return (c < 16 ? '0' : '') + c.toString(16)
  }

  var nanolight = function (code) {
    return code.split(/("(?:.|\n)*?"|'(?:.|\n)*?'|`(?:.|\n)*?`|\/\*(?:.|\n)*?\*\/|<!--(?:.|\n)*?-->|\/\/.*?\n)/g).map(function (b) {
      var g = G(I + Q, b, "'") || G('double-' + Q, b, '"') || G('template', b, '`')
      if (g) {
        return [X, D, H(b), Y, b[0], Z, X, N, g.c, S, Y, g.t, Z, X, D, H(b), Y, b[0], Z].join('')
      }
      g = G('block', b, '/*', '*/') || G('xml', b, '<!--', '-->') || G(I + 'line', b, '//', '\n')
      return (g ? [X, N, g.c, C, Y, b, Z] : b.split(R).map(F)).join('')
    }).join('')
  }

  if (typeof module !== 'undefined') {
    module.exports = nanolight
  } else if (typeof window !== 'undefined') {
    window['module.exports']['nanolight'] = nanolight
  }
})()
